% C  PROCEDURE COMPUTES TRIADS: NODE TRIADS,CROSS-SECTION TRIADS ,
% C  ELEMENT TRIAD AND COORDINATES OF FICTITIOUS NODES IN THE CASE OF
% C  BEAM ELEMENTS ECCENTRICALLY CONNECTED TO NODES NI,NJ
% C  AND NET DEFORMATIONS FOR BEAM AND TRUSS ELEMENTS
% C  REQNUM=1 =>COMPUTE TRIADS AND FXTNI,...FZTNJ  ONLY
function [FT,LVTI,LVTJ] =local_transformation (x0,xt,x1x2_vector,B1I,B2I,B1J,B2J)
    %      *   (XNI,XNJ,XNK,YNI,YNJ,YNK,ZNI,ZNJ,ZNK,XTNI,XTNJ,YTNI,YTNJ,
    %      *   ZTNI,ZTNJ,B1I,B2I,B1J,B2J,ECC,
    %      *   FT,NETDEF,LT,FXTNI,FXTNJ,FYTNI,FYTNJ,FZTNI,FZTNJ,REQNUM)
    % C                           ************
    %
    %       INTEGER REQNUM,I,J,K
    %       DOUBLE PRECISION XNI,XNJ,XNK,YNI,YNJ,YNK,ZNI,ZNJ,ZNK,XTNI,XTNJ,
    %      *   YTNI,YTNJ,ZTNI,ZTNJ,L0,LT,W(3),
    %      *   B1I(3),B2I(3),B1J(3),B2J(3),ECC(4),
    %      *   FXTNI,FXTNJ,FYTNI,FYTNJ,FZTNI,FZTNJ,DX,DY,DZ,
    %      *   F0(3,3),VTI(3,3),VTJ(3,3),BTI(3,3),BTJ(3,3),FT(3,3),
    %      *   NETDEF(6),TRFT(3,3),LVTI(3,3),LVTJ(3,3),EC1,EC2,EC3,EC4
    % C.......................................................................
    
    % C  COMPUTE LOCAL TRIAD IN CONFIGURATION 0 --TERMS IN GLOBAL COORDS
    F0(:,1)= (x0(2,:)-x0(1,:))'; F0(:,1)=F0(:,1)/norm(F0(:,1));
    F0(:,3)=cross(F0(:,1),x1x2_vector); F0(:,3)=F0(:,3)/norm(F0(:,3));
    F0(:,2)=cross(F0(:,3),F0(:,1));
    
    % C  COMPLETE NODE TRIADS BTI,BTJ-TERMS IN GLOBAL COORDS
    BTI(:,1)=B1I;
    BTI(:,2)=B2I;
    BTJ(:,1)=B1J;
    BTJ(:,2)=B2J;
    
    BTI(:,3)=cross(BTI(:,1),BTI(:,2));
    BTJ(:,3)=cross(BTJ(:,1),BTJ(:,2));
    
    %     C  COMPUTE VTI,VTJ-TERMS IN GLOBAL COORDS
    VTI=BTI*F0;
    VTJ=BTJ*F0;
    
    
    % C  COMPUTE ELEMENT TRIAD FT-TERMS IN GLOBAL COORDS
    % C  MATRIX FT IS DIAGONAL SUBMATRIX of the TRANSF.MATRIX
    FT(:,1)= (xt(2,:)-xt(1,:))'; FT(:,1)=FT(:,1)/norm(FT(:,1));
    FT(:,3)=cross(FT(:,1),x1x2_vector); FT(:,3)=FT(:,3)/norm(FT(:,3));
    FT(:,2)=cross(FT(:,3),FT(:,1));
    
    % C  COMPUTE TERMS OF VTI,VTJ IN ELEMENT COORDS
    LVTI=FT'*VTI;
    LVTJ=FT'*VTJ;
end
