% Constructor of the finite element block class.
%
% function retobj = feblock_thermal_nonlinear (varargin)
%
% This class implements the finite element operations for thermal diffusion
% where the thermal properties may be functions of the temperature
% (resulting thus in a nonlinear problem).  
%
% See discussion of constructors in <a href="matlab:helpwin 'FAESOR/classes/Contents'">classes/Contents</a>. 
% Options: those recognized by feblock, plus
% surface_transfer = surface transfer coefficient
%
function retobj = feblock_thermal_nonlinear (varargin)
    class_name='feblock_thermal_nonlinear';
    if (nargin == 0)
        parent = feblock_diffusion;
        self.matstates= [];
        retobj = class(self,class_name,parent);
        return;
    elseif (nargin == 1)
        arg = varargin{1};
        if strcmp(class(arg),class_name) % copy constructor.
            retobj = arg;
            return;
        else
            options =varargin{1};
            parent = feblock_diffusion(varargin{:});
            self.matstates= [];
            retobj = class(self,class_name,parent);
            return;
        end
    else
        error('Illegal arguments!');
    end
    return;
end
