% Compute the  thermal capacity matrices of the individual gcells.
%
% function ems = thermal_capacity(self, geom, temp)
%
% Return an array of them so they may be assembled.
%    Call as
%       ems = thermal_capacity(feb, geom, temp)
%    where
%       geom=geometry field
%       temp=temperature field
%
% 
% The specific heat may depend on the temperature.  The thermal
% property would define the specific heat as a function of the
% temperature, which is then evaluated at each quadrature point.
% 
function ems = lumped_capacity(self, geom, temp)
    ems=capacity(self, geom, temp);
    for j=1:length(ems)% Hinton, Rock, Zienkiewicz lumping
        Me=get(ems(j),'mat');
        em2=sum(sum(Me));
        dem2=sum(diag(Me));
        ems(j)=set(ems(j),'mat',diag(diag(Me)/dem2*em2));
    end
end
