% Evaluate the derivatives of the basis function matrix.
%
% function Nder = bfundpar (self, param_coords)
%
% Returns an array of NFENS rows, and DIM columns, where
%    NFENS=number of nodes, and
%    DIM=number of spatial dimensions.
% Call as:
%    Nder = bfundpar(g, pc)
% where g=gcell
%       pc=parametric coordinates, -1 < pc(j) < 1, length(pc)=dim.
%
function Nder = bfundpar (self, param_coords)
    xi=param_coords(1);
    Nder = [-27/16*xi^2+1/16+9/8*xi
  81/16*xi^2-9/8*xi-27/16
 -81/16*xi^2-9/8*xi+27/16
    27/16*xi^2+9/8*xi-1/16];
   return;
end



