% Constructor  of a general-connectivity N-node  geometric cell set.
%
% function retobj = gcellset_N (varargin)
%
% Need exactly 1 argument: an Parameters structure with attributes 
%  nfens = number of connected nodes
%  conn = array of connected node Numbers
%
% See discussion of constructors in <a href="matlab:helpwin 'FAESOR/classes/Contents'">classes/Contents</a>. 
% Parameters: same as gcellset.
%
function retobj = gcellset_N (varargin)
    class_name='gcellset_N';
    if (nargin == 0)
         error ('Need an argument');
    elseif (nargin == 1)
        arg = varargin{1};
        if strcmp(class(arg),class_name) % copy constructor.
            retobj = arg;
            return;
        else
            Parameters=varargin{1}; 
            parent=gcellset(Parameters);
            retobj = class(struct([]),class_name, parent);
            return;
        end
    else
        error('Illegal arguments!');
    end
    return;
end
