% get: Get property from the specified object and return the value.
%   Call as:
%      get(obj), or
%      get(obj,prop_name)
%   where
%      obj       - object
%      prop_name - property name
%
%   The first form returns the list of property names as a string,
%   the second form returns the value of the named property.
%
function val = get(self,varargin)
if (nargin == 1)
    val={{{'A'}, {'cross-sectional area'}};...
        {{'I2'}, {'moment of inertia of the cross-section bending about the local x2 axis'}};...
        {{'I3'}, {'moment of inertia of the cross-section bending about the local x3 axis'}};...
        {{'IT'}, {'torsional moment of inertia of the cross-section for twisting about the local x1 axis'}};...
        {{'x1x2_vector'}, {'vector in the local x1,x2 plane'}}...
        };
    val = cat(1, val, get(self.gcellset));
    return;
else
    prop_name=varargin{1};
    switch prop_name
        case 'dim'
            val = 1;
        case 'A'
            val = self.A;
        case 'I2'
            val = self.I2;
        case 'I3'
            val = self.I3;
        case 'IT'
            val = self.IT;
        case 'x1x2_vector'
            val = self.x1x2_vector;
        otherwise
            val = get(self.gcellset, prop_name);
    end
end
