% Necessary changes when switching from SOFEA to FAESOR

% These changes concern mostly simulation scripts. Internal operations of 
% the toolkit have been already updated.. .

% Replace
length(gcells)
% with
count(gcells)


% Replace
length(fens)
% with
count(fens)


% Replace concatenation of arrays of geometric cells
          gcells= cat(2,gcells1,gcells2);
% with the call to a method
          gcells= cat(gcells1,gcells2);

          
          
% Replace the indexing of the array
          gcells(cl)
% with the method call
          subset(gcells,cl)

          
          
% Replace the concatenation of geometric cell into an array
           gcells =[gcells1,gcells2];
% with the method call
          gcells =cat(gcells1,gcells2);
          
          
          
% Replace loops in which connectivity is retrieved from individual
% geometric cells 
    for i= 1:length(eg)
        conn = get(eg(i),'conn');
        theta = set_ebc(theta, conn, conn*0+1, [], conn*0);
    end
% with retrieval of connectivity from the set with subsequent loop 
% over the rows of the array conns
    conns = get(eg,'conn');
    for i= 1:size(conns,1)
        conn = conns(i,:);
        theta = set_ebc(theta, conn, conn*0+1, [], conn*0);
    end
    
% In fact,an even better way of writing the above operation (essentially 
% applying boundary conditions to all nodes onnected by given gcells) is
    conn = connected_nodes(eg);
    theta = set_ebc(theta, conn, conn*0+1, [], conn*0);
    
    
    
% Replace graphics loops
for i=1:length (gcells)
    draw(gcells(i), gv, struct ('x',geomT, 'u',0*geomT,...
        'colorfield',colorfield, 'shrink',1));
end
% with
draw(gcells, gv, struct ('x',geomT, 'u',0*geomT,...
        'colorfield',colorfield, 'shrink',1));
% or with
for i=1:count(gcells)
    draw(subset(gcells,i), gv, struct ('x',geomT, 'u',0*geomT,...
        'colorfield',colorfield, 'shrink',1));
end
% The first form will definitely give much better performance! 
% Drawing individual gcells is expensive, while it can be done 
% efficiently for the entire set in one shot...


          
% Replace manipulations of the node coordinates 
% in the form of a loop          
for i=1:length (fens)
    xyz=get (fens(i),'xyz');
    x=xyz(1); y=xyz(2); z=xyz(3);
    xyz= [0, y-iR, z];
    xyz = xyz*rotmat([0, 0, -x])+ [0,iR,0];
    fens(i)=set(fens(i),'xyz', xyz);
end
% 	with retrieval of array of nodal coordinates, modification, and resetting 
xyz=get (fens,'xyz');
for i=1:length (fens)
    x=xyz(i,1); y=xyz(i,2); z=xyz(i,3);
    xyz(i,:)= [0, y-iR, z];
    xyz(i,:) = xyz(i,:)*rotmat([0, 0, -x])+ [0,iR,0];
end
fens=set(fens,'xyz', xyz);