function inflate_af28
Meshfile='LA_2_Low_Rez_L-V-clean-mesh';
    Geometry_scaling=  1.0;
    
    geotol = 0.01;
    
    
    [fens,gcells]=Abaqus_mesh_import([Meshfile '.INP'],Geometry_scaling,~true);
%     smoothingoptions=[];
% [ignore,v] =smoothing(get(gcells,'conn'),get(fens,'xyz'),smoothingoptions);
% fens=set(fens,'xyz',v);
    
    balloon_location = [ 25   10   7.0333];
    balloon_radius =28/2;
    
    
    R=balloon_radius;
    R2=1.9*R;
    

    geom = field(struct('name',['geom'], 'dim', 3, 'fens',fens));
    x=get(geom,'values');
    xrange = [min(x(:,1)),max(x(:,1))];
    yrange = [min(x(:,2)),max(x(:,2))];
    zrange = [min(x(:,3)),max(x(:,3))];
    
    bdry_gcells = mesh_bdry(gcells, []);
 
    %     gv=drawmesh({fens,bdry_gcells},'gcells','facecolor','none')
    xmin_plane =gcell_select(fens, bdry_gcells, ...
        struct ('box',[xrange(1) xrange(1) -inf inf -inf inf],'inflate',geotol));
    xmax_plane =gcell_select(fens, bdry_gcells, ...
        struct ('box',[xrange(2) xrange(2) -inf inf -inf inf],'inflate',geotol));
    ymin_plane =gcell_select(fens, bdry_gcells, ...
        struct ('box',[-inf inf yrange(1) yrange(1) -inf inf],'inflate',geotol));
    ymax_plane =gcell_select(fens, bdry_gcells, ...
        struct ('box',[-inf inf yrange(2) yrange(2) -inf inf],'inflate',geotol));
    zmin_plane =gcell_select(fens, bdry_gcells, ...
        struct ('box',[-inf inf -inf inf zrange(1) zrange(1)],'inflate',geotol));
    zmax_plane =gcell_select(fens, bdry_gcells, ...
        struct ('box',[-inf inf -inf inf zrange(2) zrange(2)],'inflate',geotol));
    
    others =setdiff(1:length(bdry_gcells),[xmin_plane,xmax_plane,...
        ymin_plane,ymax_plane,zmin_plane,zmax_plane]);
    bg =subset(bdry_gcells,others);
    %     gv=drawmesh({fens,bdry_gcells},'gcells','facecolor','red')
     bgBlood =bg;
    

     gv=graphic_viewer;
     gv=reset(gv,[]);
        draw_ellipsoid(gv, balloon_location, eye(3), balloon_radius*[1,1,1], struct('facecolor',[1,1,1]*0.7,'tessel',12,'facealpha',0.8))
%        drawmesh({fens,bdry_gcells},'gv', gv,'gcells','facecolor','none','edgecolor','none')
%         drawmesh({fens,bgContact},'gv', gv,'gcells','facecolor','blue','facealpha',0.5,'edgecolor','none')
        drawmesh({fens,bgBlood},'gv', gv,'gcells','facecolor','red','facealpha',0.8,'edgecolor','none')
%         drawmesh({fens,subset(bdry_gcells,[xmin_plane,xmax_plane,...
%             ymin_plane,ymax_plane,zmin_plane,zmax_plane])},'gv', gv,'gcells','facecolor','yellow','facealpha',0.5,'edgecolor','none')
    view3d rot;
    
    c =clock; disp(['Started ' num2str(c(4)) ':' num2str(c(5)) ':' num2str(c(6)) ' '])
    % Parameters:
    E=1;
    nu= 0.48;
    nsteps = 2;
    target_radius =R/3;
    radius = 2/3*R;
    penalty = 4*E;

    function  gap = get_gap(surface_data,x)
        q=x-balloon_location;
        gap =norm(q)- radius;
        if (gap>0), gap = 0; end
    end
    function normal = get_normal(surface_data,x)
        q=x-balloon_location;
        normal = q/norm(q);
    end

    % Mesh
        cn = connected_nodes(bgBlood);
    gap_gcells= gcellset_P1 (struct('conn',cn));
    
    % Material
    prop = property_linel_iso (struct('E',E,'nu',nu));
    mater = mater_defor_ss_linel_triax (struct('property',prop));
    % Finite element block
    gl=gcell_select (fens,gcells,struct('from',balloon_location,'distance',2*balloon_radius,'any_node',true));
    feb = feblock_defor_ss (struct('mater',mater,'gcells',gcells,...
        'integration_rule',simplex_nq_rule(3)));
    gapfeb = feblock_defor_gap (struct('gcells',gap_gcells,...
        'get_gap',@get_gap,'get_normal',@get_normal,'penalty',penalty));
    sfeb1 = feblock_defor_ss (struct('gcells',bgBlood));
    % Geometry
    geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));
    % Define the displacement field
    u   = clone(geom,'u');
    u   = u*0; % zero out
    % Apply EBC's
    ebc_fenids=fenode_select (fens,struct('from',balloon_location,'distance',2*balloon_radius));
    ebc_fenids= setdiff(1:length(fens),ebc_fenids);
    ebc_prescribed=ebc_fenids*0+1;
    ebc_comp=[];% all components
    ebc_val=ebc_fenids*0;% zero displacement
    u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
    u   = apply_ebc (u);
%     Number equations
    u   = numbereqns (u);
    get(u,'neqns')

    %     h=progressbar(mfilename);
    for step= 1:nsteps
        disp(['Step ' num2str(step)])
        radius= radius +target_radius/nsteps;
        u   = u*0; % zero out
        tic;
        K = start (sparse_sysmat, get(u, 'neqns'));
        K = assemble (K, cat(2,stiffness(feb, geom, u),stiffness(gapfeb, geom, u)));
        disp([' Stiffness matrix assembly ' num2str(toc)])
        F = start (sysvec, get(u, 'neqns'));
        lm =get(F,'vec');
         gv=reset (graphic_viewer,[]);%%% turn on for online graphics
        for augit= 1:3
            disp([' Aug Iteration ' num2str(augit)])
            F = assemble (start (sysvec, get(u, 'neqns')), gap_loads(gapfeb, geom, u));
            gl =get(F,'vec');
            tic;
            %                         us = get(K,'mat')\(-lm+gl);%bicg(get(K,'mat'),(-lm+gl), 1e-6, 140, diag(diag (get(K,'mat'))));
            %             us = bicgstab(@afun,(-lm+gl), 1e-6, 20,  []);
            %             us = pcg(@afun,(-lm+gl), 1e-6, 500,  preconditioner);
            us = gmres(@afun,(-lm+gl), 12,1e-6, 5,preconditioner);
            disp(['      Solve ' num2str(toc)])
            u = scatter_sysvec(u, us);
            lm=lm-gl;
           %  draw(feb,gv, struct ('x', geom, 'u', (1)*u,'facecolor','none','edgecolor','black'));
        end
        draw(sfeb1,gv, struct ('x', geom, 'u',(1)*u,'facecolor','red'));%%% turn on for online graphics
        draw_ellipsoid(gv, balloon_location, eye(3), radius*[1,1,1], struct('facecolor',[1,1,1]*0.7,'tessel',12,'facealpha',0.5))
              pause(0.5)
      geom =geom+u;% update geometry
        %         if isempty(progressbar((step/nsteps),h)), return, end;
    end
    function y = afun(x)
        y = matvecprod(K, x);
    end
    function M =  preconditioner
        M=diag(K);
    end

    c =clock; disp(['Stopped ' num2str(c(4)) ':' num2str(c(5)) ':' num2str(c(6)) ' '])
    % Plot
%     gv=graphic_viewer;
%     gv=reset (gv,[]);
%     scale=1;
%     %         draw(feb,gv, struct ('x', geom, 'u', 0*u, 'facecolor','none'));
% %     draw(feb,gv, struct ('x', geom, 'u', (0)*u,'facecolor','red'));
%     xlabel('X');
%     ylabel('Y');
%     zlabel('Z');
%     hold on

fens=set(fens,'xyz',gather(geom,1:length(fens),'values','noreshape'));

end