kappa=[0.2 0; 0 0.2]; % conductivity matrix
Q=1; % uniform heat source
num_integ_pts=1; % 1-point quadrature
[fens,gcells] = targe2_mesher({... 
        ['curve 1 line -30 -20 30 -20'],...
        ['curve 2 line 30 -20 30 20'],...
        ['curve 3 line 30 20 -30 20'],...
        ['curve 4 line -30 20 -30 -20'],...
        'subregion 1  property 1 boundary 1 2 3 4 ',...
        ['m-ctl-point constant 2']
        }, 1.0);
prop=property_diffusion(struct('conductivity',kappa,'source',Q));
mater=mater_diffusion (struct('property',prop));
feb = feblock_diffusion (struct ('mater',mater,...
    'gcells',gcells,...
    'integration_rule',tri_rule(num_integ_pts)));
geom = field(struct('name',['geom'], 'dim', 2, 'fens',fens));
theta=field(struct('name',['theta'], 'dim', 1, 'nfens',...
    get(geom,'nfens')));
bg=mesh_bdry(gcells,[]);
fenids=connected_nodes(bg);
prescribed=ones(length(fenids),1);
comp=[];
val=zeros(length(fenids),1)+  0;
theta = set_ebc(theta, fenids, prescribed, comp, val);
theta = apply_ebc (theta);
theta = numbereqns (theta);
K = start (sparse_sysmat, get(theta, 'neqns'));
K = assemble (K, conductivity(feb, geom, theta));
F = start (sysvec, get(theta, 'neqns'));
F = assemble (F, source_loads(feb, geom, theta));
F = assemble(F, nz_ebc_loads_conductivity(feb, geom, theta));
theta = scatter_sysvec(theta, get(K,'mat')\get(F,'vec'));

% Plot
gv=graphic_viewer;
gv=reset (gv,[]);
set_graphics_defaults
T=get(theta,'values');
dcm=data_colormap(struct('range',[min(T),max(T)],'colormap',jet));
colorfield=field(struct ('name', ['colorfield'], 'data',...
    map_data(dcm, T)));
geomT=field(struct ('name', ['geomT'], ...
    'data',[get(geom,'values'), 0.02*get(theta,'values')]));
draw(gcells, gv, struct ('x',geomT, 'u',0*geomT,...
    'colorfield',colorfield, 'facealpha',0.3));
draw(gcells, gv, struct ('x',geom, 'u',0*geom, ...
    'facecolor','none'));
draw_integration_points(feb, gv, struct ('x',geom,'u',0*geom, ...
    'theta', theta, 'scale', 0.49,'color','red'));
axis equal;

gv=graphic_viewer;
gv=reset (gv,[]);
set_graphics_defaults
draw(gcells, gv, struct ('x',geom, 'u',0*geom, ...
    'facecolor','none'));
XY=get(geom,'values');
conn= get(gcells,'conn');
tricontour(XY,conn,T,15)
view(2)


gv=graphic_viewer;
gv=reset (gv,[]);
set_graphics_defaults
draw(gcells, gv, struct ('x',geom, 'u',0*geom, ...
    'facecolor','none'));
XY=get(geom,'values');
conn= get(gcells,'conn');
tricontour(XY,conn,T,15)
draw_integration_points(feb, gv, struct ('x',geom,'u',0*geom, ...
    'theta', theta, 'scale', 0.29,'color','red'));
view(2)


 