
E =40e9;
nu=0.45;
stabfact=  0.2*E/2;
%     E/3/( 1-2*nu)
rho=8.6e3;
nus = [(1:100)*0+nu];
vini =0.23e3;
Newmarkg = 1/2; Newmarkb = 1/4*(1/2+Newmarkg)^2;
%     Newmarkg = 0.6; Newmarkb = 1/4*(1/2+Newmarkg)^2;

maxit = 30;
tup = 1;
dt =0.5e-3;
nincr =round(tup/dt);

graphics =false;
cam = [  -81.9855   82.4325   65.1450   -1.7698    2.5016    1.4936         0         0    1.0000    2.3047];
scale=1;
DimensionA =18;, DimensionB=1; Length=1;
na = 8;
nb = 3;
nL = 1;
tol= 0.001;


Report =@(x) (disp(x) );
%     Report =@(x) ([]);




eix=1;
clear eltyd


% eltyd(eix).label ='H8';
% eltyd(eix).mf =@h8Mesh;
% eltyd(eix).blf =@feblock_defor_nonlinear;
% eltyd(eix).integration_rule= gauss_rule (3,2);
% eltyd(eix).line_integration_rule=gauss_rule (1,2);
% eltyd(eix).stabfact =stabfact;
% eltyd(eix).styl='rx-.';
% eix=eix+1;

%    eltyd(eix).label ='NICE-T4';
%    eltyd(eix).mf =@t4Mesh;
%    eltyd(eix).blf =@feblock_defor_nonlinear_nice;
%    eltyd(eix).integration_rule= simplex_nq_rule (3);
%    eltyd(eix).line_integration_rule=tri_rule(1);
%    eltyd(eix).stabfact =stabfact;
%    eltyd(eix).styl='m^-';
%    eix=eix+1;
%
    eltyd(eix).label ='NICE-H8';
    eltyd(eix).mf =@h8Mesh;
    eltyd(eix).blf =@feblock_defor_nonlinear_nice;
    eltyd(eix).integration_rule= tensprod_nq_rule (struct('dim',3,'order',1));
    eltyd(eix).line_integration_rule=tensprod_nq_rule (struct('dim',1,'order',1));
    eltyd(eix).stabfact =stabfact;
    eltyd(eix).styl='md-';
    eix=eix+1;

%     eltyd(eix).label ='NICE-T4d';
%     eltyd(eix).mf =@t4cyld;
%     eltyd(eix).blf =@feblock_defor_nonlinear_nice;
%     eltyd(eix).integration_rule= simplex_nq_rule (3);
%     eltyd(eix).line_integration_rule=gauss_rule(1, 3);
%     eltyd(eix).stabfact =stabfact/4;
%     eltyd(eix).styl='mv-';
%     eix=eix+1;

%     eltyd(eix).label ='H27';
%     eltyd(eix).mf =@h8cylH27;
%     eltyd(eix).blf =@feblock_defor_nonlinear;
%     eltyd(eix).integration_rule=gauss_rule (3,3);
%     eltyd(eix).line_integration_rule=gauss_rule(1, 3);
%     eltyd(eix).styl='ks-';
%     eix=eix+1;

%     eltyd(eix).label ='NICE-H27';
%     eltyd(eix).mf =@h8cylH27;
%     eltyd(eix).blf =@feblock_defor_nonlinear_nice;
%     eltyd(eix).integration_rule=tensprod_nq_rule (struct('dim',3,'order',2));
%     eltyd(eix).line_integration_rule=tensprod_nq_rule (struct('dim',1,'order',2));
%     eltyd(eix).styl='mh-';
%     eix=eix+1;

%     eltyd(eix).label ='NICE-H64';
%     eltyd(eix).mf =@h8cylH64;
%     eltyd(eix).blf =@feblock_defor_nonlinear_nice;
%     eltyd(eix).integration_rule=tensprod_nq_rule (struct('dim',3,'order',3));
%     eltyd(eix).line_integration_rule=tensprod_nq_rule (struct('dim',1,'order',3));
%     eltyd(eix).styl='mh-';
%     eix=eix+1;


for eix = 1:length(eltyd)

    % Mesh
    [fens,gcells]=block(DimensionA, DimensionB, Length, na,nb,nL);
    fens = transform_apply(fens,@(x,d)(x-[DimensionA/2,DimensionB/2,0]), []);

    prop = property_linel_iso (struct('E',E,'nu',nu,'rho',rho));
    mater = mater_defor_neohook(struct('property',prop));
    % Finite element block

    propa = property_linel_iso (struct('E',E,'nu',nu,'rho',rho));
    mata = mater_defor_neohook(struct('property',propa));
    feba = eltyd(eix).blf (struct ('mater',mata,...
        'gcells',gcells,...
        'integration_rule',eltyd(eix).integration_rule));


    % Geometry
    geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));
    % Define the displacement field
    u   = 0*geom; % zero out
    % Apply EBC's
    ebc_fenids=fenode_select (fens,struct('box',[-Inf,Inf,-Inf,Inf,Inf,-Inf],'inflate',10));
    ebc_prescribed=ones(1,length (ebc_fenids));
    ebc_comp=ebc_fenids*0+3;
    ebc_val=ebc_fenids*0;
    u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
    u   = apply_ebc (u);

    % Number equations
    u   = numbereqns (u);

    if graphics, gv=graphic_viewer; end

    if graphics,
        gv=reset(clear(gv,[]),[]);
        %                     camset(gv,cam);
        view(2);
        draw(feba,gv, struct ('x', geom,'u',u, 'facecolor','Yellow'));
        %                 headlight(gv);
        pause(0.5);
        %                     cam =camget(gv);
    end

    % Now comes the nonlinear solution
    tup = 1;
    u = u*0; % zero out the displacement
    v = u*0; % zero out the Velocity
    a = u*0; % zero out the Acceleration
    Es=[]; Ks=[];
    us = {};
    xyz = gather(geom,(1:length(fens)),'values','noreshape');
    vxyz = gather(v,(1:length(fens)),'values','noreshape');
    vxyz =xyz*skewmat( [0, 0, vini]);
    v= scatter (v,(1:length(fens)),vxyz);
    utol = 1e-10*get(u, 'neqns');
    tipu = [];

    K = start (sparse_altassem_sysmat, get(u, 'neqns'));
    %K_geo = start (sparse_altassem_sysmat, get(u, 'neqns'));
    %K_stab = start (sparse_altassem_sysmat, get(u, 'neqns'));
    M = start (sparse_altassem_sysmat, get(u, 'neqns'));
    feb = eltyd(eix).blf (struct ('mater',mater, 'gcells',gcells,...
        'integration_rule',eltyd(eix).integration_rule));
    %                 feb = eltyd(eix).blf (struct ('mater',mater, 'gcells',gcells,...
    %                     'integration_rule',tensprod_nq_rule (struct('dim',3,'order',1))));
    Mems=mass(feb, geom, u);% Constant mass matrix
    for  j = 1:length(Mems)
        Mems(j) =set(Mems(j),'mat',get(Mems(j),'mat')/(Newmarkb*dt^2));
    end
    clear feb
    %         K = start (sparse_sysmat, get(u, 'neqns'));

    t=0; % time=load magnitude
    incr=1;
    while (incr <= nincr)
        Report(['Increment ' num2str(incr) ]); % pause
        % Initialization
        u1 = u; % guess
        du = 0*u; % this will hold displacement increment
        u1 = apply_ebc(u1);
        du = apply_ebc(du);
        a1 = -(1/Newmarkb/dt)*v -(1/2-Newmarkb)/Newmarkb*a;
        v1 = v + dt*((1-Newmarkg)*a + Newmarkg*a1);
        F0 = start (sysvec, get(u, 'neqns'));
        ap =-(1/Newmarkb/dt^2)*u -(1/Newmarkb/dt)*v -((1/2-Newmarkb)/Newmarkb)*a;
        F0 = assemble (F0, inertial_force(feba, geom, (-Newmarkb*dt^2)*ap, Mems));

        E = defor_energy(feba,geom,u1,u);   Es=[Es,E];
        Vv=gather_sysvec(v);
        MVv =get(assemble (start (sysvec, get(u, 'neqns')),inertial_force(feba, geom, v, Mems)),'vec');
        Kin =(Vv'*MVv)/2;
        %                     invalid_eqnum=0;
        %                     Kin = 0;
        %                     for  j = 1:length(Mems)
        %                         eqnums = get(Mems(j), 'eqnums');
        %                         mat    = get(Mems(j), 'mat');
        %                         emask=eqnums>invalid_eqnum;
        %                         valid_eqnums=eqnums(emask);
        %                         %Ks=Ks+mat(emask,emask)*Vv(get(Mems(j),'eqnums'));
        %                         Kin=Kin+0.5*Vv(emask)'*mat(emask,emask)*Vv(emask);
        %                     end
        Kin = Kin*(Newmarkb*dt^2); Ks=[Ks,Kin];
        Energy =Es + Ks;
        if ( ~graphics )
            plot(Ks); hold on
            plot(Es); hold on
            plot(Energy,'r'); hold on
            pause( 0.1);
        end

        iter=1;
        while 1
            feb1=feba;
            F = F0;
            [feba,evsa] = restoring_force(feba,geom,u1,u);
            F = assemble (F, evsa);
            [febstab,evsa] = restoring_force_stab(feba,geom,u1,u,eltyd(eix).stabfact);
            F = assemble (F, evsa);
            F = assemble (F, inertial_force(feba, geom, (-1)*u1, Mems));
            ems=cat(2,stiffness(feba, geom, u1,u),...
                stiffness_geo(feba, geom, u1,u),...
                stiffness_stab(feba, geom, u1,u,eltyd(eix).stabfact), ...
                Mems);
            K =assemble (K,ems);
            K = external_decomposition (K,  []);
            du = scatter_sysvec(du, K\F); % Displacement increment
            %                 max(abs(get(F,'vec')))
            u1 = u1 + du;   % increment displacement
            v1 = v1 + (Newmarkg/Newmarkb/dt)*du;
            a1 = a1 + (1/Newmarkb/dt^2)*du;
            K = reinitialize (K);
            Report(['   It. ' num2str(iter) ': ||du||=' num2str(norm(du))]);
            if (max(abs(gather(du,[],'values'))) < utol) break; end;% convergence check
            if (iter >maxit)% bailout for failed convergence
                error( [' Possible failed convergence']);
            end
            iter=iter+1;
        end
        [feb,ignore] = restoring_force(feba,geom,u1,u);        % final update
        Report(['    Converged for t=' num2str(t)]); % pause
        us {end +1} = u1;
        u = u1;       % update the displacement
        v = v1;       % update the displacement
        a = a1;
        norm(a)
        
        if graphics && (mod(incr,1)==0)
            gv=reset(clear(gv,[]),[]);
            cmap = jet(16);
            Cauchy = [];
            for j=1:6
                fld = field_from_integration_points(feb, geom, u1, [], 'Cauchy',j);
                nvals=get(fld,'values');%min(nvals),max(nvals)
                Cauchy = [Cauchy,nvals];
            end
            nvals =sqrt(( (Cauchy(:,1)-Cauchy(:,2)).^2+...
                (Cauchy(:,3)-Cauchy(:,2)).^2 +...
                (Cauchy(:,1)-Cauchy(:,3)).^2 +...
                6*(Cauchy(:,4).^2+Cauchy(:,5).^2 +Cauchy(:,6).^2))/2)/1e9;% in GPa
            nvalsrange=[min(nvals),max(nvals)];
            dcm=data_colormap(struct ('range',nvalsrange, 'colormap',cmap));
            colorfield=field(struct ('name', ['colorfield'], 'data',map_data(dcm, nvals)));
            draw(feba,gv, struct ('x', geom, 'u', u,'colorfield',colorfield, 'shrink',1.0));
            draw(feba,gv, struct ('x', geom, 'u', 0*u,'facecolor','none', 'shrink',1.0));
            % draw(efeb,gv, struct ('x', geom, 'u', 0*u,'facecolor','red', 'shrink',1.0));
            colormap(cmap);
            cbh=colorbar;
            set(cbh,...
                'Position',[0.815 0.15 0.05 0.7],...
                'YLim',[0,1],...
                'YTick',[0,1],...
                'YTickLabel',{[num2str(nvalsrange(1))],[num2str(nvalsrange(2))]});%{[num2str((min(nvals)))],[num2str((max(nvals)))]}
            set(get(cbh,'XLabel'),'String','von Mises');
            view(2);
            drawnow;
        end

        t = t + dt;
        incr = incr + 1;
    end
    clear K
    save ([mfilename '-nc' num2str(nc) '-nt' num2str(nt) '-' eltyd(eix).label])

end
