npart= 59;
E=200000; rho=7.85e-9; A=200; L=7850; Ihat =10;
cd=sqrt(E/rho);
dt=L/npart/cd
nsteps = round(2.3*L/(cd)/dt);
    tspan= [0,nsteps*dt];
    tfinal =tspan(2);
    
graphics = ~false;
scale =1;
T2 =7e-4;
    
[fens,gcells]= L2_block(L,npart,A);
% Finite element block
prop = property_linel_iso (struct ('E',E,'rho',rho));
mater = mater_defor_ss_linel_uniax (struct('property',prop));
feb = feblock_defor_ss(struct ('mater',mater,...
    'gcells',gcells,...
    'integration_rule',gauss_rule(1, 2)));
% Geometry
geom = field(struct ('name',['geom'], 'dim', 1, 'fens',fens));
% Define the displacement field
u   = 0*clone(geom,'u');
% Apply EBC's
% fenids=[1,n+1]; prescribed=[1, 1]; component=[1, 1]; val=[0,0];
% u   = set_ebc(u, fenids, prescribed, component, val);
% u   = apply_ebc (u);
% Number equations
u   = numbereqns (u);
v = 0*u;% zero velocity
% Assemble the stiffness matrix
K = start (sparse_sysmat, get(u, 'neqns'));
K = assemble (K, stiffness(feb, geom, u));
% Assemble the consistent mass matrix
M = start (sparse_sysmat, get(u, 'neqns'));
M = assemble (M, mass(feb, geom, u));
% Assemble the lumped mass matrix
%     M = start (sparse_sysmat, get(u, 'neqns'));
%     M = assemble(M, elemat( struct('eqnums', (1:n-1),'mat', eye(n-1) * mu*L/n)));
% Solve
Kmat = get(K,'mat');
Mmat = get(M,'mat');
U0 = gather_sysvec(u);
V0= gather_sysvec(v);
A0 =Mmat\(-Kmat*U0);

n1 =gather(u,1,'eqnums');
F =0*U0; F(n1) =2*Ihat/T2/pi;
    
t=0;
o2=eigs(Kmat,Mmat,1,'LM');
dt= 0.999* 2/sqrt(o2)
 
ngraphics=  max (round(5*(1e-5)/dt),1);
igraphics =ngraphics-1;
if graphics
    set_graphics_defaults(figure)
end
snapshot =0;
while t <tfinal
     U1 = U0 +dt*V0+(dt^2)/2*A0;
    A1 = Mmat\(-Kmat*U1 +F*(t<T2)*sin(pi/T2*t));
    V1 = V0 +dt/2* (A0+A1);
    U0 = U1;
    V0 = V1;
    A0 = A1;
    t=t+dt;
   igraphics=igraphics+1;
    if graphics & igraphics==ngraphics
        u = scatter_sysvec(u, U1);
        X =gather(geom,1:count(fens),'values');
        U =gather(u,1:count(fens),'values');
        plot(X,U);
        labels('x','u')
        set(gca,'ylim',[-0.,3*0.6]);
            set(gca,'xlim',[0,L]);
            set_graphics_defaults(gcf)
        view(2); pause(0.1);
%         saveas(gcf, [mfilename '-33-' num2str(snapshot) '.png'], 'png');
        snapshot = snapshot +1;
        igraphics= 0;
    end
end

