% Mesh of a straight beam member given by the location of the end vertices
%
% function [fens,gcells] = Beam_member(xyz,nL)
%
% xyz = Two rows, one vertex location per row;
% nL = Divided into this many elements
% 
function [fens,gcells] = Beam_member(xyz,nL,constructor,options)
    npts=size(xyz,1);
    if npts==2
        lo=min(xyz);
        hi=max(xyz);
    end

    if ~exist('block_mesh_handle')
        block_mesh_handle =@H8_block;
    end

    [fens,gcells] = L2_block(2,nL,[]);

    pxyz=get(fens,'xyz');
    nxyz=zeros(size(pxyz, 1),3);
    for i=1:count(fens)
        N = bfun(pxyz(i,:)-1);% shift coordinates by -1
        nxyz(i,:) =N'*xyz;
    end
    fens=set(fens,'xyz',nxyz);
    
    options.id=get(gcells,'id');
    options.conn=get(gcells,'conn');
    gcells=constructor(options);
end

function val = bfun(param_coords)
    val = [(1 - param_coords(1)); (1 + param_coords(1))] / 2;
end
