% Extrude a mesh of quadrilaterals into a mesh of hexahedra.
%
% function [fens,gcells] = Q4_extrude(fens,gcells,nLayers,extrusionh)
%
% fens,gcells = nodes and cells of the Quadrilateral mesh,
% nLayers= number of layers,
% extrusionh= handle to function that computes the extrusion vector
%   nxyz=extrusionh(xyz,k)
function [fens,gcells] = Q4_extrude(fens,gcells,nLayers,extrusionh)
    nn1 =count(fens);
    nnt=nn1*nLayers;
    ngc=count(gcells)*nLayers;
    hconn=zeros(ngc,8);
    xyz1=get(fens,'xyz');
    xyz =zeros(size(xyz1,1)*(nLayers+1),3);
    cn=connected_nodes(gcells);
    for j=1:length(cn)
        xyz(cn(j),:) =extrusionh(xyz1(cn(j),:),0);
    end
    for k=1:nLayers
        for j=1:length(cn)
            f=cn(j)+k*nn1;
            xyz(f,:) =extrusionh(xyz1(cn(j),:),k);
        end
    end
    
    conn = get(gcells,'conn');
    gc=1;
    for k=1:nLayers
        for i=1:count(gcells)
            hconn(gc,:)=[conn(i,:)+(k-1)*nn1, conn(i,:)+k*nn1];
            gc=gc+1;
        end
    end
    gcells =gcellset_H8(struct('id',1:ngc,'conn',hconn));
    fens =fenodeset(struct('id',1:size(xyz,1),'xyz',xyz));
end
